class Module {
  /** e.g. Module userProfile */
  constructor (name, objects) {
    this.name = name
    this.state = {}
    this.actionCreators = {}
    this.reducer = (state = [], action) => state
    Object.keys(objects).forEach(key => {
      this[key] = objects[key]
    })
  }

  /** e.g. Upload the avatar file */
  addAsync (name, stateVariables, asyncFunction) {
    const states = ['start', 'success', 'failure']
    const actionCreators = {}
    this.state = {...this.state, ...stateVariables}
    states.forEach(state => {
      this.state[`${name}State`] = state
      const actionType = `${this.name}_${name}_${state}`.toUpperCase()
      const actionCreatorName = `${name}${state[0].toUpperCase() + state.substring(1)}`
      actionCreators[actionCreatorName] = args => {
        return {
          type: actionType,
          ...args
        }
      }
    })
    this.actionCreators = {...this.actionCreators, ...actionCreators}
  }

  addDBField (name, stateVariables, asyncFunction, dbConnection) {
    this.dbConnection = dbConnection
    const states = ['start', 'success', 'failure']
    const actionCreators = {}
    this.state = {...this.state, ...stateVariables}
    states.forEach(state => {
      this.state[`${name}State`] = state
      const actionType = `${this.name}_${name}_${state}`.toUpperCase()
      const actionCreatorName = `${name}${state[0].toUpperCase() + state.substring(1)}`
      actionCreators[actionCreatorName] = args => {
        return {
          type: actionType,
          ...args
        }
      }
    })
    this.actionCreators = {...this.actionCreators, ...actionCreators}
  }
}

export default Module
